﻿@{ 
    Layout = null;
}
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <title>@ViewBag.Title   </title>

    @Scripts.Render("~/bundles/modernizr")
    <link rel="stylesheet" href="~/Content/vendors/mdi/css/materialdesignicons.min.css">
    <link rel="stylesheet" href="~/Content/vendors/base/vendor.bundle.base.css">
    <link rel="stylesheet" href="~/Content/css/style.css">
    <link rel="shortcut icon" href="images/favicon.png" />
    <link rel="stylesheet" href="~/Content/css/jquery-ui.min.css">
    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/jqueryval")
    <link rel="stylesheet" href="~/Content/Site.css">
    <link rel="stylesheet" href="~/Content/css/toastr.css">

</head>


<body>
    <div class="container-scroller">
        <div class="loader"></div>
        @Html.Partial("_HeaderView")
        <div class="container-fluid page-body-wrapper">
            <nav class="sidebar sidebar-offcanvas" id="sidebar">
                <ul class="nav">

                    <li class="nav-item">

                        <div class="" id="ui-basic">
                            <ul class="nav flex-column sub-menu" id="list-menu">
                            </ul>
                        </div>
                    </li>

                </ul>
            </nav>
            <div class="main-panel">
                <div class="content-wrapper">
                    <div class="row">
                       
                        <div class="col-sm-12">
                            <div class="card" id="session">
                                <h2 class="card-header text-center">Section (<span id="questionCategory"></span>) </h2>
                                <div class="row">
                                    <div class="col-md-6 ">
                                        <div class="form-group m-4">
                                            <label>Kindly Upload your sample here (Excel Format only)</label>
                                            @* <input type="file" name="img[]" class="file-upload-default">*@

                                            <input type="file" id="filetoup" name="img[]" class="file-upload-default">
                                            <div class="input-group col-xs-12">
                                                <input type="text" class="form-control file-upload-info" disabled="" placeholder="Upload Sample">
                                                <span class="input-group-append">
                                                    <button class="file-upload-browse btn btn-primary" type="button">Select File</button>
                                                </span>
                                            </div>
                                        </div>
                                        <div class="form-group ml-4" id="savefileBtn">

                                        </div>
                                    </div>
                                    <div class="col-md-4 ">
                                        <div class="form-group mt-5" id="fileSaved">

                                        </div>
                                    </div>
                                </div>


                                <div class="card-body">
                                    <h5 class="card-title"></h5>
                                    <form id="form-questn">
                                    </form>
                                </div>
                                <div class="card-footer float-btn">
                                    @*<a href="#" class="btn btn-danger">Save Session</a> &nbsp; &nbsp;*@
                                    <span class="" id="btnSave">  </span>
                                </div>
                            </div>
                        </div>

                    </div>
                </div>
                <footer class="footer">
                    <div class="d-sm-flex justify-content-center justify-content-sm-between">
                        <span class="text-muted text-center text-sm-left d-block d-sm-inline-block">Copyright © 2020 <a href="https://www.ubagroup.com/" target="_blank">UBA Group</a>. All rights reserved.</span>
                    </div>
                </footer>
            </div>
        </div>
    </div>

    <script type="text/javascript">
    var allQuestions = [];
        var counter = 0;
        var sessionTotal = 0;
        var fileUpload = [];
        var fileCheck = "";

     var optionListUrl = '@Url.Action("GetAllQuestionsAsync", "AssessmentPortal")';
        questionArray();
        // Display all question
    function questionArray() {
        $.ajax({
            type: 'GET',
            url: optionListUrl,
           // data: "",
            dataType: 'json',
            success: function (data) {
                allQuestions = data.data;
                $.each(allQuestions, function (i, value) {
                    $("#list-menu").append($('<li class="nav-item">  <a class="nav-link" href="#" onclick=moveCategory(' + i + ') id="check' + i + '" > ' + value.CategoryName + '</a></li>'));

                });
                   displayCategoryQuestions(counter)
            }
        });
        }

        function displayCategoryQuestions(value) {
            counter = value;
            $('#fileSaved').empty();
            $("#questionCategory").html(allQuestions[counter].CategoryName);
            formFileUpload(allQuestions[value].QuestionCategoryId);
            $("[id*='check']").removeClass("active");
            $("#check" + counter).addClass('active');
            $("#btnSave").empty();
            var arrayLength = allQuestions.length;
            var presentValue = counter + 1;
            console.log("value", counter);
            console.log("Length", allQuestions.length);
            if(counter>0)
             $("#btnSave").append($('<button type="button" onclick="previousBtn('+value+')" class="btn btn-light mr-4"> Previous  </button>'));
            $("#btnSave").append($('<button type="submit" onclick="submitForm()" class="btn btn-danger mr-2">' + (presentValue<arrayLength?'Next & Save':'Submit') + '</button>'));
            $("#form-questn").empty();

            $.each(allQuestions[value].TestQuestion, function (i, value) {
                $("#form-questn").append($('<div class="card question mb-2 p-3"> <h4> ('+(i+1)+')  ' + value.QuestionText + ' </h4><div class="option" > <label><input type="radio" id="opt'+(value.QuestionId)+'v'+1+'" name="' + value.QuestionId + '" value="1" class="choice" required /> Yes</label> <br /> <label><input type="radio" required id="opt'+(value.QuestionId)+'v'+2+'"   name="' + value.QuestionId + '" value="2" class="choice" /> No</label> <br /> <label><input type="radio" id="opt'+(value.QuestionId)+'v'+3+'"   name="' + value.QuestionId + '" value="3" class="choice" />  Not Applicable</label>  </div> </div>'));
            })
            //Testing checked answer.
            SavedAnswers(allQuestions[value].QuestionCategoryId);
            $("#opt1034v1").attr('checked', true);
        }
        function fileSavedRecord(fileCheckee) {
            $('#fileSaved').empty();
           // var urlSavedAns = "@Url.Content("'+fileCheckee+'")";
            return   $('#fileSaved').append('<a target="_blank" href='+fileCheckee+' class=""> <i class="mdi mdi-download mr-3 icon-lg text-warning"></i>Download Sample Uploaded</a>');
        }

        function SavedAnswers(QuestionCatId) {
            var urlSavedAns='@Url.Action("GetAllResult")'
               $.ajax({
            url: urlSavedAns,
            type: 'GET',
            datatype: 'json',
            contentType: false,
            processData: false,
            async: false,
            data: 'QuestionCatId='+QuestionCatId+'',
                   success: function (response) {
                       if (response.data) {
                           $.each(response.data.answers, function (key, value) {
                               console.log('Value' + value)
                               $('#opt' + value.QuestionId + 'v' + value.answerEnum + '').attr('checked', true);
                           });

                           fileCheck = response.data.FileDto;
                           if (fileCheck != null) {
                               fileSavedRecord(fileCheck);
                           }
                       }
                   }
        });
        }

        function previousBtn(value) {
            value -= value;
            displayCategoryQuestions(value);
        }
        function moveCategory(value) {
            //var check = validation();
            //if (check) {


               // displayCategoryQuestions(value);
           // }

        }
        function formFileUpload(cateId) {
            //Button
            $("#filetoup").val(null);
             $(".file-upload-info").val('Upload Sample');
             $("#savefileBtn").empty();
            $("#savefileBtn").append($(' <button onclick="saveFile(' + cateId + ')" class="btn btn-primary  btn-fw"> Upload Sample</button>'))


        }


        function fetchRecords() {
            // Fetch all the records from backend;
            // patchvalue
        }
        function saveFile(cateId) {

            var fileUpload = $('#filetoup').get(0);
            var files = fileUpload.files;
            console.log(files[0]);
            if (files[0] == undefined) {
                toastr.error("No file Selected", "File Validation");
                return;
            }
            var url='@Url.Action("UploadAnswerAsync","AssessmentPortal")'
        var fileData = new FormData();
            fileData.append(files[0].name, files[0]);
            fileData.append("CategoryId", cateId);


        $.ajax({
            url: url,
            type: 'post',
            datatype: 'json',
            contentType: false,
            processData: false,
            async: false,
            data: fileData,
            success: function (response) {
                console.log(response)
                if (response.data == "failed") {
                    toastr.error("Incorrect file format", "File failed to upload")
                }
                else {
                    fileCheck = response.data;
                    toastr.success("Successfully Upload Files");
                    fileSavedRecord(fileCheck);
                }
            }
        });
        }
        function submitForm() {
            // first check ur local db
            // if exist patch value to the db
            // else not check online;
            // and save into local data
            // if there's nothing online
            var arrayLength = allQuestions.length;
            var presentValue = counter + 1;

              if (fileCheck == null) {
                  toastr.error("Kindly upload correct Sample before proceeding", "Validation");
                  return;
            }
            var check = validation();

            if (check) {
                var formObject = $("#form-questn").serializeArray();
                var CategoryId = allQuestions[counter].QuestionCategoryId;
                var formData = { QuestionCategoryId: CategoryId, Questionlists: formObject, IsCompleted:presentValue == arrayLength };
                var url = '@Url.Action("SaveQuestionByCategoryAsync", "AssessmentPortal")';
                var saveData = $.ajax({
                    type: 'POST',
                    url: url,
                    data: JSON.stringify(formData),
                    contentType: 'application/json; charset=utf-8',
                    dataType: "json",
                    success: function (resultData) {
                        if (presentValue < arrayLength)
                            toastr.success("Move to the next Question Category", "Notification");
                        else {
                            toastr.success("Your assessment has been submitted", "Notification");
                            CorrectivePlan(resultData.scheduleId);
                        }


                         if (presentValue < arrayLength) {
                displayCategoryQuestions(presentValue)
            }
                    }
                });
            }
//            localStorage.setItem("","");
        }
        function validation() {
            // file Upload
            // Input type
            var getcount = allQuestions[counter].Count;
            var fieldCount = $("#form-questn").serializeArray().length;
            if (fieldCount != getcount) {
                console.log('fieldCount', fieldCount);
                 console.log('getcount',getcount);
                getcount =getcount- fieldCount  ;
                console.log(getcount);
                toastr.error('kindly, select all the entries <br/>  '+ getcount +'  fill(s) left!!!', "Validation");
                return false;
            }
            return true;
        }

            function CorrectivePlan(id) {
    var url = '@Url.Action("CorrectivePlan", "AssessmentPortal")?AssSchId='+id+'';
    window.location.href = url;
}

    </script>
    @Scripts.Render("~/bundles/bootstrap")
    <script src="~/Content/vendors/base/vendor.bundle.base.js"></script>
    <script src="~/Scripts/js/toastr.js"></script>
    <script src="~/Scripts/js/off-canvas.js"></script>
    <script src="~/Scripts/js/hoverable-collapse.js"></script>
    <script src="~/Scripts/js/template.js"></script>
    <script src="~/Scripts/js/loader.js"></script>

    @Scripts.Render("~/bundles/jquery-ui")

    <script src="~/Scripts/js/file-upload.js"></script>

</body>
</html>

<!-- JQUERY FOR NEXT AND PREV FUNCTIONALITY -->





